]> git.meshlink.io Git - catta/blobdiff - initscript/fedora/avahi-dnsconfd.in
init: fix fedora init script handling for PIDFILE (rhbz#600430)
[catta] / initscript / fedora / avahi-dnsconfd.in
index 5fbdb01ec68ee283bd393239580d297fd58c6565..df8b964a9927dac7b66fa346218f85face0eefef 100644 (file)
@@ -1,55 +1,63 @@
-#! /bin/sh
+#!/bin/sh
 #
-# avahi-daemon:       Starts the Avahi dns configuration daemon
+# avahi-dnsconfd: Starts the Avahi dns configuration daemon
 #
-# chkconfig: - 34 66
-# description: avahi-dnsconfd connects to a running avahi-daemon and runs  the  script
-#       /etc/avahi/dnsconf.action for each unicast DNS server that is announced
-#       on the local LAN. This is useful for configuring unicast DNS servers in
-#       a DHCP-like fashion with mDNS.
+# chkconfig:   - 96 02
+# description: avahi-dnsconfd connects to a running avahi-daemon and runs  the  script \
+#              /etc/avahi/dnsconf.action for each unicast DNS server that is announced \
+#              on the local LAN. This is useful for configuring unicast DNS servers in \
+#              a DHCP-like fashion with mDNS.
 # processname: avahi-dnsconfd
-# config: 
+# pidfile:     @localstatedir@/run/avahi-dnsconfd.pid
 
-OTHER_AVAHI_OPTS=""
+AVAHI_BIN=@sbindir@/avahi-dnsconfd
+AVAHI_OPTS="-D"
+
+if [ "$1" = 'status' ]; then
+    test -x $AVAHI_BIN || exit 4
+else
+    test -x $AVAHI_BIN || exit 5
+fi
 
 # Source function library.
 . /etc/init.d/functions
-
 . /etc/sysconfig/network
 
-# Check that networking is configured.
-[ ${NETWORKING} = "no" ] && exit 0
+LOCKFILE=@localstatedir@/lock/subsys/avahi-dnsconfd
+PIDFILE=@localstatedir@/run/avahi-dnsconfd.pid
+RETVAL=0
 
-AVAHI_BIN=@sbindir@/avahi-dnsconfd
-test -x $AVAHI_BIN || exit 5
+base=${0##*/}
 
 start() {
+    # Check that networking is configured.
+    [ ${NETWORKING} = "no" ] && exit 1
+
        echo -n $"Starting Avahi DNS daemon... "
-        $AVAHI_BIN -D
-       RETVAL=$?
-       [ $RETVAL = 0 ] && success $"$base startup" || failure $"$base startup"
-       echo
-       return $RETVAL
+        daemon --pidfile=${PIDFILE} $AVAHI_BIN $AVAHI_OPTS
+        RETVAL=$?
+        echo
+        [ $RETVAL -eq 0 ] && touch ${LOCKFILE}
+        return $RETVAL
 }
 
 stop() {
-        echo -n "Shutting down Avahi DNS daemon: "
-        $AVAHI_BIN -k
-       RETVAL=$?
-       echo
-       return $RETVAL
+        echo -n $"Shutting down Avahi DNS daemon: "
+        killproc -p ${PIDFILE} $AVAHI_BIN
+        RETVAL=$?
+        [ $RETVAL -eq 0 ] && rm -f ${LOCKFILE} ${PIDFILE}
+        echo
+        return $RETVAL
 }
 
 reload() {
-        echo -n "Reloading Avahi DNS daemon... "
-        $AVAHI_BIN -r
-       RETVAL=$?
-       [ $RETVAL = 0 ] && success $"$base startup" || failure $"$base startup"
-       echo
-       return $RETVAL
+        echo -n $"Reloading Avahi DNS daemon... "
+        killproc -p ${PIDFILE} $AVAHI_BIN -HUP
+        RETVAL=$?
+        echo
+        return $RETVAL
 }
 
-
 restart() {
        stop
        start
@@ -66,22 +74,24 @@ case "$1" in
        stop
        ;;
   status)
-        $AVAHI_BIN -c
-       [ $? = 0 ] && echo "Avahi DNS daemon is running" || echo "Avahi DNS daemon is not running"
+        status -p ${PIDFILE} $AVAHI_BIN
+        RETVAL=$?
        ;;
   restart)
        restart
        ;;
   reload)
-        reload 
+        reload
        ;;
   condrestart)
-        $AVAHI_BIN -c
-        [ $? = 0 ] && restart || :
+       if [ -f $LOCKFILE ]; then
+               restart
+       fi
        ;;
   *)
        echo $"Usage: $0 {start|stop|status|restart|condrestart}"
-       exit 1
+       exit 2
+       ;;
 esac
 
-exit $?
+exit $RETVAL